package parser;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author edwajohn
 */
public class Main {

  public static int runTests() throws FileNotFoundException, IOException {
    Tests tests = new Tests();

    final String dot = Character.toString((char) 0x25CF);

    // TODO: uncomment tests as you develop code

//    //------------------------------------------------------------
//    // All possible items tests
//    //------------------------------------------------------------
//    {
//    Grammar grammar = new Grammar("data/Simple.cfg");
//      ArrayList<Item> items
//              = Parser.computeAllPossibleItems(grammar.rules, grammar.follow);
//      System.out.println("Items (" + items.size() + "):");
//      System.out.println("Items:");
//      for (int i = 0; i < items.size(); i++) {
//        System.out.println(i + " " + items.get(i).toString());
//      }
//      tests.test(items.size() == 12);
//      tests.test(items.get(0).toString().equals("[goal -> ● list, EOF]"));
//      tests.test(items.get(1).toString().equals("[goal -> list ●, EOF]"));
//      tests.test(items.get(2).toString().equals("[list -> ● list FOO, FOO]"));
//      tests.test(items.get(3).toString().equals("[list -> list ● FOO, FOO]"));
//      tests.test(items.get(4).toString().equals("[list -> list FOO ●, FOO]"));
//      tests.test(items.get(5).toString().equals("[list -> ● list FOO, EOF]"));
//      tests.test(items.get(6).toString().equals("[list -> list ● FOO, EOF]"));
//      tests.test(items.get(7).toString().equals("[list -> list FOO ●, EOF]"));
//      tests.test(items.get(8).toString().equals("[list -> ● FOO, FOO]"));
//      tests.test(items.get(9).toString().equals("[list -> FOO ●, FOO]"));
//      tests.test(items.get(10).toString().equals("[list -> ● FOO, EOF]"));
//      tests.test(items.get(11).toString().equals("[list -> FOO ●, EOF]"));
//    }
//
//
//    {
//      Grammar grammar = new Grammar("data/Paren.cfg");
//      ArrayList<Item> items
//              = Parser.computeAllPossibleItems(grammar.rules, grammar.follow);
//      System.out.println("Items (" + items.size() + "):");
//      for (int i = 0; i < items.size(); i++) {
//        System.out.println(i + " " + items.get(i).toString());
//      }
//      tests.test(items.size() == 38);
//      tests.test(items.get(0).toString().equals("[goal -> ● list, EOF]"));
//      tests.test(
//              items.get(5).toString().equals("[list -> ● list pair, CPAREN]"));
//      tests.test(
//              items.get(22).toString().equals(
//                      "[pair -> OPAREN ● list CPAREN, CPAREN]"));
//    }
//
//    {
//      Grammar grammar = new Grammar("data/Expr.cfg");
//      ArrayList<Item> items
//              = Parser.computeAllPossibleItems(grammar.rules, grammar.follow);
//      System.out.println("Items (" + items.size() + "):");
//      for (int i = 0; i < items.size(); i++) {
//        System.out.println(i + " " + items.get(i).toString());
//      }
//      tests.test(items.size() == 162);
//      tests.test(items.get(0).toString().equals("[goal -> ● expr, EOF]"));
//      tests.test(
//              items.get(28).toString().equals(
//                      "[expr -> expr MINUS ● term, PLUS]"));
//      tests.test(
//              items.get(73).toString().equals(
//                      "[term -> term DIVIDE factor ●, EOF]"));
//    }
//
//    //------------------------------------------------------------
//    // Closure tests
//    //------------------------------------------------------------
//    {
//      Grammar grammar = new Grammar("data/Simple.cfg");
//      ArrayList<Item> items
//              = Parser.computeAllPossibleItems(grammar.rules, grammar.follow);
//      Set<Item> CC0 = Parser.computeClosure(items.get(0), items, grammar);
//      tests.test(CC0.size() == 5);
//      Set<String> CC0_str = new HashSet<>();
//      for (Item item : CC0) {
//        CC0_str.add(item.toString());
//        System.out.println(item.toString());
//      }
//      tests.test(CC0_str.contains("[goal -> ● list, EOF]"));
//      tests.test(CC0_str.contains("[list -> ● FOO, FOO]"));
//      tests.test(CC0_str.contains("[list -> ● list FOO, EOF]"));
//      tests.test(CC0_str.contains("[list -> ● FOO, EOF]"));
//      tests.test(CC0_str.contains("[list -> ● list FOO, FOO]"));
//
//      Set<Item> CC1 = Parser.computeClosure(items.get(6), items, grammar);
//      tests.test(CC1.size() == 1);
//      Set<String> CC1_str = new HashSet<>();
//      for (Item item : CC1) {
//        CC1_str.add(item.toString());
//        System.out.println(item.toString());
//      }
//      tests.test(CC1_str.contains("[list -> list ● FOO, EOF]"));
//
//    }
//
//    {
//      Grammar grammar = new Grammar("data/Expr.cfg");
//      ArrayList<Item> items
//              = Parser.computeAllPossibleItems(grammar.rules, grammar.follow);
//      Set<Item> CC0 = Parser.computeClosure(items.get(0), items, grammar);
//      tests.test(CC0.size() == 45);
//      Set<String> CC0_str = new HashSet<>();
//      System.out.println("Closure (" + CC0.size() + "):");
//      for (Item item : CC0) {
//        CC0_str.add(item.toString());
//        System.out.println(item.toString());
//      }
//      tests.test(CC0_str.contains("[factor -> ● IDENTIFIER, MULTIPLY]"));
//      tests.test(CC0_str.contains("[factor -> ● FLOAT, DIVIDE]"));
//      tests.test(CC0_str.contains("[factor -> ● OPAREN expr CPAREN, DIVIDE]"));
//      tests.test(CC0_str.contains("[term -> ● term MULTIPLY factor, MINUS]"));
//
//      Set<Item> CC1 = Parser.computeClosure(items.get(124), items, grammar);
//      tests.test(CC1.size() == 1);
//      Set<String> CC1_str = new HashSet<>();
//      System.out.println("Closure (" + CC1.size() + "):");
//      for (Item item : CC1) {
//        CC1_str.add(item.toString());
//        System.out.println(item.toString());
//      }
//      tests.test(CC1_str.contains("[factor -> OPAREN expr ● CPAREN, DIVIDE]"));
//    }

    //------------------------------------------------------------
    // Output number of tests that succeeded
    //------------------------------------------------------------
    System.out.println(tests.getSuccesses() + "/" + tests.getN()
            + " tests succeeded");
    return tests.getFailures();
  }

  /**
   * @param args the command line arguments
   * @throws java.io.IOException
   */
  public static void main(String[] args) throws IOException {
    runTests();
  }
}
