/*
 * Look for TODO comments in this file for suggestions on how to implement
 * your parser.
 */
package parser;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Set;
import java.util.Stack;
import lexer.ExprLexer;
import lexer.ParenLexer;
import lexer.TinyLexer;
import org.antlr.v4.runtime.ANTLRFileStream;
import org.antlr.v4.runtime.Lexer;
import org.antlr.v4.runtime.Token;
import org.antlr.v4.runtime.Vocabulary;

/**
 *
 * @author edwajohn
 */
public class Parser {

  final Grammar grammar;

  /**
   * Action table for bottom-up parsing. Accessed as
   * actionTable.get(state).get(terminal).
   */
  private final HashMap<Integer, HashMap<String, Action>> actionTable;
  /**
   * Goto table for bottom-up parsing. Accessed as gotoTable.get(state).get(NT).
   */
  private final HashMap<Integer, HashMap<String, Integer>> gotoTable;

  public Parser(String grammarFilename) throws IOException {
    grammar = new Grammar(grammarFilename);

    actionTable = new HashMap<>();
    gotoTable = new HashMap<>();
  }

  // TODO: Implement this method. You'll iterate through all rules, look at all
  // possible lookaheads (anything that follows the lhs -- use the follow set)
  // and then create the item using Item.create().
  static public ArrayList<Item> computeAllPossibleItems(List<Rule> rules, HashMap<String, HashSet<String>> follow) {
    ArrayList<Item> items = new ArrayList<>();
    return items;
  }

  // Pass-through function to computeClosure implementation.
  static public Set<Item> computeClosure(
          Item seed, ArrayList<Item> items, Grammar grammar) {
    Set<Item> seeds = new HashSet<>();
    seeds.add(seed);
    return computeClosure(seeds, items, grammar);
  }

  // TODO: implement computeClosure.
  // You'll get the nonterminals using grammar.nonterminals.
  static public Set<Item> computeClosure(
          Set<Item> seed, ArrayList<Item> items, Grammar grammar) {
    return new HashSet<>();
  }


}
