/*
 * Do not modify this file.
 */
package parser;

import java.util.ArrayList;

/**
 *
 * @author edwajohn
 */
public class Rule {

  private final String lhs;
  private ArrayList<String> rhs;

  public Rule(String lhs) {
    this.lhs = lhs;
    rhs = new ArrayList<>();
  }

  @Override
  public String toString() {
    String ret = lhs + " -> ";
    for (String symbol : getRhs()) {
      ret = ret + symbol + " ";
    }
    return ret;
  }

  public String getLhs() {
    return lhs;
  }

  public ArrayList<String> getRhs() {
    if (rhs.isEmpty()) {
      rhs.add("EPSILON");
    }
    return rhs;
  }

  public void addRhs(String symbol) {
    rhs.add(symbol);
  }

}
